Imports System.IO
Imports System.IO.Ports
Imports System.Text
Imports System.Type
Public Class Form1
    Dim mTemperatur1 As Short
    Dim mTemperatur2 As Short
    Dim mTemperatur3 As Short
    Dim mTemperatur4 As Short
    Dim maZeichenkette(8) As Byte

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        GetComPortConfiguration()
        SetComPortSpezialConfiguration()
        TextBox1.Text = 1
        TextBox2.Text = 1
        TextBox3.Text = 1
        TextBox4.Text = 1
        Send()

    End Sub
    
    Private Sub cbxComPort_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles cbxComPort.KeyPress
        If (Me.cbxComPort.Text.Length <> 0) Then
            Try
                Me.SerialPort1.PortName = Me.cbxComPort.Text
            Catch ex As Exception

            End Try
        End If
    End Sub
    Private Sub cbxBaudRate_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles cbxBaudRate.KeyPress
        If (Me.cbxComPort.Text.Length <> 0) Then
            Try
                Me.SerialPort1.BaudRate = CInt(Me.cbxBaudRate.Text)
            Catch ex As Exception

            End Try
        End If
    End Sub
    Private Sub cbxDataBits_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles cbxDataBits.KeyPress
        If (Me.cbxComPort.Text.Length <> 0) Then
            Try
                Me.SerialPort1.DataBits = CInt(Me.cbxDataBits.Text)
            Catch ex As Exception

            End Try
        End If
    End Sub
    Private Sub cbxStopBits_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles cbxStopBits.KeyPress
        If (Me.cbxComPort.Text.Length <> 0) Then
            Try
                Me.SerialPort1.StopBits = CInt(Me.cbxStopBits.Text)
            Catch ex As Exception

            End Try
        End If
    End Sub
    Private Sub cbxParity_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles cbxParity.KeyPress
        If (Me.cbxComPort.Text.Length <> 0) Then
            Try
                Me.SerialPort1.Parity = Me.cbxParity.SelectedIndex
            Catch ex As Exception

            End Try
        End If
    End Sub


    Private Sub SetComPortSpezialConfiguration()
        With Me.SerialPort1

            .Close()

            .BaudRate = 9600
            .Parity = Parity.Even
            .StopBits = 1
            .DataBits = 8

            .DiscardNull = False
            .Handshake = Handshake.None
            .ParityReplace = 63           ' "?"

            .ReceivedBytesThreshold = 12
            .Encoding = Encoding.UTF8

            .DtrEnable = False
            .ReadBufferSize = 4096
            .WriteBufferSize = 4096
        End With

    End Sub
    Private Sub GetComPortConfiguration()
        ' Hole Liste aller angeschlossenen Ports
        Dim aNames() As Object
        Dim StrBuffer As String
        Dim aDataBitList As String()

        aNames = Me.SerialPort1.GetPortNames()

        With Me.cbxComPort
            For Each StrBuffer In aNames
                .Items.Add(StrBuffer)
            Next
            .SelectedIndex = 0
        End With

        Me.cbxBaudRate.SelectedIndex = 0
        Me.cbxDataBits.SelectedIndex = 0
        Me.cbxStopBits.SelectedIndex = 0


        aNames = [Enum].GetNames(GetType(System.IO.Ports.Parity))
        For Each StrBuffer In aNames
            Me.cbxParity.Items.Add(StrBuffer)
        Next
        Me.cbxParity.SelectedIndex = 0
        Me.tbxTimer.Text = Me.Timer1.Interval.ToString()

    End Sub
    Private Sub ParseIncommingData(ByVal vData() As Byte)
        'rechnet die Ist - Temperaturen aus und stellt in Label dar
        Dim L1, L2, L3, L4, L5, L6 As Double
        L3 = ((vData(1) * 256) + (vData(0))) * 0.0625
        L4 = ((vData(3) * 256) + (vData(2))) * 0.0625
        L5 = ((vData(5) * 256) + (vData(4))) * 0.0625

        L6 = ((vData(7) * 256) + (vData(6))) * 0.0625
        L1 = ((vData(9) * 256) + (vData(8))) * 0.0625
        L2 = ((vData(11) * 256) + (vData(10))) * 0.0625

        Me.Label1.Text = L1.ToString
        Me.Label2.Text = L2.ToString
        Me.Label3.Text = L3.ToString
        Me.Label4.Text = L4.ToString
        Me.Label5.Text = L5.ToString
        Me.Label6.Text = L6.ToString

    End Sub


    Private Sub tbxTimer_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles tbxTimer.KeyPress
        Select Case e.KeyChar
            Case "0" To "9"
            Case Chr(8)         ' RckTaste gedckt
            Case Chr(13)        ' Enter gedrckt
                Try
                    If Me.tbxTimer.Text.Length > 0 Then
                        Dim value As Integer = CInt(Me.tbxTimer.Text)
                        If value > 10 Then
                            Timer1.Interval = value
                        Else
                            Me.tbxTimer.Text = "10"
                        End If
                        'Me.cRs232.TimeOutInterval = value
                    Else
                        Me.tbxTimer.Text = Me.Timer1.Interval.ToString()
                    End If
                Catch ex As Exception

                End Try
            Case Else
                e.Handled = True
        End Select
    End Sub


    Private Sub btnSerialConfig_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSerialConfig.Click
        Me.SerialPort1.Close()
        Me.gbxSerialSettings.Enabled = True
        Me.btnSerialConfig.Enabled = False
    End Sub

    Private Sub btnReady_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReady.Click
        Try
            Me.gbxSerialSettings.Enabled = False
            Me.btnSerialConfig.Enabled = True
            Me.SerialPort1.Open()
        Catch ex As Exception

        End Try
    End Sub

    Private Sub TextBox1_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox1.KeyPress
        Select Case e.KeyChar
            Case "0" To "9"
            Case Chr(8)         ' RckTaste gedckt
            Case Chr(13)        ' Enter gedrckt
            Case Else
                e.Handled = True
        End Select

    End Sub
    Private Sub TextBox2_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox2.KeyPress
        Select Case e.KeyChar
            Case "0" To "9"
            Case Chr(8)         ' RckTaste gedckt
            Case Chr(13)        ' Enter gedrckt
            Case Else
                e.Handled = True
        End Select
    End Sub
    Private Sub TextBox3_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox4.KeyPress
        Select Case e.KeyChar
            Case "0" To "9"
            Case Chr(8)         ' RckTaste gedckt
            Case Chr(13)        ' Enter gedrckt
            Case Else
                e.Handled = True
        End Select

    End Sub
    Private Sub TextBox4_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox4.KeyPress
        Select Case e.KeyChar
            Case "0" To "9"
            Case Chr(8)         ' RckTaste gedckt
            Case Chr(13)        ' Enter gedrckt
            Case Else
                e.Handled = True
        End Select
    End Sub

    Private Sub SerialPort1_DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived


        Dim aIData() As Byte                                            ' Buffer fr ankommende Daten
        Dim enc As System.Text.Encoding = System.Text.Encoding.UTF8     ' 8-Bit encoding einastellen

        If SerialPort1.BytesToRead >= 12 Then
            Dim IncommingData As String = SerialPort1.ReadExisting       ' Alle angekommenen Daten einlesen
            aIData = enc.GetBytes(IncommingData)                         ' Daten in Byte Array   
            ParseIncommingData(aIData)

            ' ....  Deine Auswertung der Daten

            Send()

        End If

    End Sub

    Private Sub Send()

        mTemperatur1 = ((Val(TextBox1.Text)) / 0.0625)
        mTemperatur2 = ((Val(TextBox2.Text)) / 0.0625)
        mTemperatur3 = ((Val(TextBox3.Text)) / 0.0625)
        mTemperatur4 = ((Val(TextBox4.Text)) / 0.0625)

        'teilt die Temperaturen in 2 Byte auf
        maZeichenkette(1) = mTemperatur1 \ 256
        maZeichenkette(0) = mTemperatur1 Mod 256
        maZeichenkette(3) = mTemperatur2 \ 256
        maZeichenkette(2) = mTemperatur2 Mod 256
        maZeichenkette(5) = mTemperatur3 \ 256
        maZeichenkette(4) = mTemperatur3 Mod 256
        maZeichenkette(7) = mTemperatur4 \ 256
        maZeichenkette(6) = mTemperatur4 Mod 256

        ' sende das Array Zeichenkette
        SerialPort1.Write(maZeichenkette, 0, maZeichenkette.Length)

        ' lschender Ein- und Ausgangspuffer
        SerialPort1.DiscardInBuffer()
        SerialPort1.DiscardOutBuffer()


    End Sub

End Class
